
#define HV_COPY WM_USER + 0
#define HV_COPYHEX WM_USER + 1
#define HV_GETSEL WM_USER + 2
#define HV_SETSEL WM_USER + 3
#define HV_SELALL WM_USER + 4
#define HV_GETSELTEXT WM_USER + 5
#define HV_SETHANDLE WM_USER + 6
#define HV_SETCOLOR WM_USER + 7
#define HV_UNDO WM_USER + 8
#define HV_REDO WM_USER + 9
#define HV_CANUNDO WM_USER + 10
#define HV_CANREDO WM_USER + 11
#define HV_TEXTREADIN WM_USER + 12
#define HV_HEXREADIN WM_USER + 13
#define HV_APPLYMODIFY WM_USER + 14
#define HV_FINDTEXT WM_USER + 15

#define HV_EN_CHANGE 0
#define HV_EN_SELCHANGE 1

#define HV_COLOR_BG0 0
#define HV_COLOR_BG1 1
#define HV_COLOR_ADDR 4
#define HV_COLOR_HEX 5
#define HV_COLOR_TEXT 6
#define HV_COLOR_MODIFY 7

#if defined(__cplusplus) && !defined(CINTERFACE)
extern "C" BOOL InitHexViewClass(VOID);
#else
BOOL InitHexViewClass(VOID);
#endif

#define HV_FIND_HEX 0
#define HV_FIND_TEXT 1
#define HV_FIND_MATCHCASE 2

typedef struct _HV_FIND
{
	LONG cpMin; 
    LONG cpMax;
	PVOID pMem;
	ULONG nLen;
	DWORD dwFlags;
} HV_FIND, *PHV_FIND;
